/*
 Languages for Scientific Computing
 ----
*/
// to compile:
// gcc test8.c -o outputname -Wall 


#include <stdlib.h>   // (almost) always necessary
#include <stdio.h>    // (almost) always necessary
#include <time.h>
#include <math.h>     // for PI


int main(  )
{
  // #8  how to measure time
  
  double ctime;
  int i,j,l;

  ctime = ((double) clock ())/CLOCKS_PER_SEC;
  // casting -> more later

  
  // OPS ... LOTS OF OPS
  for( i=0; i<1000; i++ )
     for( j=0; j<1000; j++ )
	for( l=0; l<1000; l++ )
	 ;  //doing nothing  
  

  //see the difference with optimization flags: compile with -O2
  
  printf(" ctime= %.5g\n",
	  (((double) clock ())/CLOCKS_PER_SEC) - ctime);
  
  /*
  double k = 1.0001, acc = M_PI;
  double endtime;

  printf(" initial pi = %g\n", acc );
  printf(" initial pi = %.16g\n", acc );
  //  printf(" initial pi = %.32g\n", acc );

  
  ctime = ((double) clock ())/CLOCKS_PER_SEC;
  for( i=0; i<1000; i++ )
     for( j=0; j<1000; j++ )
	acc *= k;
  endtime = ((double) clock ())/CLOCKS_PER_SEC - ctime;
  printf(" final pi = %g\n", acc );
  printf(" end time= %.5g\n", endtime );
  */

  return( 0 );
}


/*
1) for, nop, time, -O0 
2) for, nop, time, -O1  or  -O2
3) for, ops, print, time, -O0
4) for, ops, print, time, -O1 or -O2
5) for, ops, no print, time, -O1 or -O2
*/

